## emacs 29.4+1

=== debian/changelog ===
emacs (1:29.4+1-5ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 14 Jan 2025 07:05:00 +0100

emacs (1:29.4+1-5) unstable; urgency=medium

  * Update to GCC 14 (Closes: #1092655).

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 13 Jan 2025 08:45:01 +0000

emacs (1:29.4+1-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Dec 2024 17:42:02 +0100

emacs (1:29.4+1-4) unstable; urgency=medium

  * 00debian.el: Mark file with 'lexical-binding: t'.
  * 00debian.el: Use setopt, not setq.
  
  * Suggest emacs-editing-major-modes.
  
  * Disable flymake included-c-header-files test to fix build with
    gcc-14 (Closes: #1074936).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 08 Dec 2024 13:38:47 +0800

emacs (1:29.4+1-3ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 Jul 2024 08:16:03 +0200

emacs (1:29.4+1-3) unstable; urgency=high

  * Mark dired-test-bug27243-02 as unstable for now.
    This appears to be a known issue:
      https://debbugs.gnu.org/cgi/bugreport.cgi?bug=27243#64
      https://debbugs.gnu.org/cgi/bugreport.cgi?bug=27243#115
    Add 0017-Mark-dired-test-bug27243-02-as-unstable-for-now.patch to
    address it.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 29 Jun 2024 15:46:01 -0500

emacs (1:29.4+1-2ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jun 2024 11:43:29 +0200

emacs (1:29.4+1-2) unstable; urgency=medium

  * Minor edits to README.source.
  * Merge divergent branches of development.
    These were accidentally introduced by the previous upload.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 25 Jun 2024 13:20:34 +0800

emacs (1:29.4+1-1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 25 Jun 2024 11:42:49 +0200

emacs (1:29.4+1-1) unstable; urgency=medium

  * Merge upstream version 29.4. (Closes: 1074137)
  * Update debian/copyright for 29.4.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 24 Jun 2024 19:34:05 -0500

emacs (1:29.3+1-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 18 May 2024 10:06:22 +0200

emacs (1:29.3+1-3) unstable; urgency=medium

  [ Sean Whitton ]
  * README.source: document our workflows.

  [ Rob Browning ]
  * README.source: add rationale.

  [ Xiyue Deng ]
  * Only install the GSettings schema in the pgtk build.  Move
    /usr/share/glib-2.0/schemas/org.gnu.emacs.defaults.gschema.xml from
    emacs-common to emacs-pgtk so that it won't trigger the addition of a
    gsettings dependency for flavors that don't use it. (Closes: 1050393)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 15 May 2024 00:37:47 -0500

emacs (1:29.3+1-2ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 May 2024 14:51:52 +0200

emacs (1:29.3+1-2) unstable; urgency=medium

  * Change native-comp-async-report-warnings-errors to `silent'.

  * d/rules: Enable running tests concurrently.
    Thanks Arto Jantunen for the patch.

  * Fix installation of desktop files for emacs-nox.
    Thanks to Brendan O'Dea for the report and fix. (Closes: #1069294)

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 20 Apr 2024 07:52:47 +0100

=== debian/control ===
Source: emacs
Section: editors
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Uploaders: Sean Whitton <spwhitton@spwhitton.name>
Build-Depends:
 autoconf,
 automake,
 bsd-mailx | mailx,
 ca-certificates,
 dbus-x11,
 gcc-14,
 debhelper-compat (= 13),
 dpkg-dev (>> 1.10.0),
 git,
 gnupg-agent,
 imagemagick,
 libacl1-dev,
 libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libcairo-dev,
 libdbus-1-dev,
 libgccjit-14-dev,
 libgif-dev,
 libgmp-dev,
 libgnutls28-dev,
 libgpm-dev [linux-any],
 libgtk-3-dev,
 libharfbuzz-dev,
 libjansson-dev,
 libjpeg-dev,
 liblcms2-dev,
 liblockfile-dev,
 libm17n-dev,
 libncurses-dev,
 liboss4-salsa-dev [hurd-i386 kfreebsd-i386 kfreebsd-amd64],
 libotf-dev,
 libpng-dev,
 librsvg2-dev,
 libselinux1-dev [linux-any],
 libsqlite3-dev,
 libsystemd-dev,
 libtiff-dev,
 libtree-sitter-dev,
 libwebp-dev,
 libxaw7-dev,
 libxml2-dev,
 procps,
 quilt (>= 0.42),
 sharutils,
 texinfo,
 xaw3dg-dev,
 zlib1g-dev,
Homepage: https://www.gnu.org/software/emacs/
Standards-Version: 3.7.2
Vcs-Browser: https://salsa.debian.org/rlb/deb-emacs
Vcs-Git: https://salsa.debian.org/rlb/deb-emacs.git

Package: emacs
Architecture: all
Depends:
 emacs-gtk (>= 1:27.1) | emacs-pgtk (>= 1:27.1) | emacs-lucid (>= 1:27.1) | emacs-nox (>= 1:27.1),
 ${misc:Depends},
Description: GNU Emacs editor (metapackage)
 GNU Emacs is the extensible self-documenting text editor.
 This is a metapackage that will always depend on the latest
 recommended Emacs variant (currently emacs-gtk).

Package: emacs-lucid
Architecture: any
Depends:
 emacs-bin-common (= ${binary:Version}),
 emacs-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides: editor, emacs, emacsen, info-browser, mail-reader, news-reader
Recommends: fonts-noto-color-emoji
Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
Conflicts: emacs-gtk, emacs-pgtk, emacs-nox
Replaces: emacs-gtk, emacs-pgtk, emacs-nox, emacs-bin-common (<< 1:29.2)
Breaks: emacs-bin-common (<< 1:29.2)
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs-gtk package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs-nox
Architecture: any
Depends:
 emacs-bin-common (= ${binary:Version}),
 emacs-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides: editor, emacs, emacsen, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
Conflicts: emacs-gtk, emacs-pgtk, emacs-lucid
Replaces: emacs-gtk, emacs-pgtk, emacs-lucid, emacs-bin-common (<< 1:29.2)
Breaks: emacs-bin-common (<< 1:29.2)
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs-gtk
Architecture: any
Depends:
 emacs-bin-common (= ${binary:Version}),
 emacs-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides: editor, emacs, emacsen, info-browser, mail-reader, news-reader
Recommends: fonts-noto-color-emoji
Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
Conflicts: emacs-pgtk, emacs-lucid, emacs-nox
Replaces: emacs-pgtk, emacs-lucid, emacs-nox, emacs-bin-common (<< 1:29.2)
Breaks: emacs-bin-common (<< 1:29.2)
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ for X11 and Wayland (instead of the Lucid toolkit
 provided by the emacs-lucid package).
 .
 If you are using Wayland, you may wish to install emacs-pgtk instead.

Package: emacs-pgtk
Architecture: any
Depends:
 emacs-bin-common (= ${binary:Version}),
 emacs-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides: editor, emacs, emacsen, info-browser, mail-reader, news-reader
Recommends: fonts-noto-color-emoji
Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
Conflicts: emacs-gtk, emacs-lucid, emacs-nox
Replaces:
 emacs-gtk,
 emacs-lucid,
 emacs-nox,
 emacs-bin-common (<< 1:29.2),
 emacs-common (<< 1:29.3+1-3~),
Breaks:
 emacs-bin-common (<< 1:29.2),
 emacs-common (<< 1:29.3+1-3~),
Description: GNU Emacs editor (with GTK+ Wayland GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ for Wayland.
 .
 If you are using exclusively X11, install emacs-gtk instead.  The
 PGTK port works less well than the standard GTK+ build in a number of
 respects.

Package: emacs-bin-common
Architecture: any
Depends: emacs-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks:
 emacs-gtk (<< 1:29.2),
 emacs-pgtk (<< 1:29.2),
 emacs-lucid (<< 1:29.2),
 emacs-nox (<< 1:29.2),
Recommends: mailutils
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs-gtk, emacs-pgtk, emacs-lucid, and emacs-nox.

Package: emacs-common
Architecture: all
Depends: emacs-el, emacsen-common (>= 3.0.0), install-info, ${misc:Depends}
#Recommends: emacs-el
Suggests: emacs-common-non-dfsg, emacs-editing-major-modes, ncurses-term
Conflicts:
 cedet,
 eieio,
 emacs-el (<< ${source:Version}),
 gnus-bonus-el,
 speedbar,
Breaks:
 apel (<< 10.8+0.20120427-4),
 edb (<< 1.32),
 egg (<< 4.2.0-2),
 elpa-cider (<< 0.19.0+dfsg-4~),
 emacs (<< 1:25),
 emacs-bin-common (<< 1:28),
 emacs-gtk (<< 1:25),
 emacs-lucid (<< 1:25),
 emacs-nox (<< 1:25),
Replaces:
 emacs-bin-common (<< 1:28)
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs-gtk, emacs-pgtk, emacs-lucid, and emacs-nox.

Package: emacs-el
Architecture: all
Depends: emacs-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file is licensed under the terms of the Gnu Public License.
# With the one additional provision that Ian Jackson's name may not be
# removed from the file.

# Copyright 2019 Andreas Beckmann <anbe@debian.org>
# Copyright 1994,1995 Ian Jackson
# Copyright 2004-2005 Jérôme Marant <jerome@debian.org>
# Copyright 1998-2020, 2022-2023 Rob Browning <rlb@defaultvalue.org>

# Originally copied from the GNU Hello Debian rules file (1.3).
# Modified for emacs by Mark Eichin <eichin@kitten.gen.ma.us>.
# Debhelper support added via one of Joey Hess' example files.
# See the debian/changelog for further historical information.

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL := /bin/bash
TERM := linux
quilt := QUILT_PATCHES=debian/patches QUILT_PATCHES_PREFIX=y quilt
pf := set -o pipefail

# This package uses debian/source/format 3.0 (quilt).

# For now we assume that emacs' versioning scheme is always
# MAJOR.MINORtinyrev where MAJOR and MINOR are integers and tinyrev is
# an optional lowercase letter (or letters).  We also assume that
# upstream uses a numbering scheme that sorts in a "Debian friendly"
# way.  So far that's always been true.  If it becomes false, some of
# the values below will have to be set manually.

# (You might imagine that a VPATH build would allow us to avoid having
#  to copy the entire source tree for each of the three builds, but it
#  turns out that the emacs build process doesn't entirely respect the
#  VPATH and modifies all kinds of files in the srcdir (e.g. *.elc,
#  *.map, etc.).

# The official upstream version defined by AC_INIT in configure.in.
upstream_ver := $(shell debian/upstream-version)
ifeq (,$(upstream_ver))
  $(error 'Unable to find upstream version number.')
endif

# This must be the version that's actually used at runtime for things
# like load-path.  It may not be the same as the upstream version
# (i.e. when you have upstream 20.5a, the functional version may still
# be 20.5), so sometimes we may have to do this by hand.
runtime_ver := $(shell $(pf); echo $(upstream_ver) | perl -pe 's/[a-z]+$$//o')
major_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/\..*$$//o')
minor_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/^[^.]*\.//o')

# From /usr/share/dpkg/pkg-info.mk
src_name := $(DEB_SOURCE)
debian_ver := $(DEB_VERSION)

# The Debian revision (i.e. the 1 from 20.5-1)
# Always everything after the last '-'
debian_rev := $(shell $(pf); echo $(debian_ver) | perl -pe 's/.*-//o')

# Might be 21.3, or it might be 21.3+1 if we've had to have more than
# one re-release of the upstream source (rare, but it happens), or if
# we have to split the package for DFSG purposes.  Always everything
# before the last '-'
debsrc_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/-[^-]+$$//o')

# Everything before the last '-' minus epoch
deborig_ver := $(shell echo $(debsrc_ver) | sed 's/^[0-9]\+://')

######################################################################
# Customizable variables

bin_priority := 28

# This might also be something like 2006-09-09 for snapshots.
menu_ver := $(major_ver)

######################################################################

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
  # Building the package with -O3 on ppc64el will cause the
  # lcms-cri-cam02-ucs test to fail.
  export DEB_CFLAGS_MAINT_STRIP = -O3
  export DEB_CFLAGS_MAINT_APPEND = -O2
endif

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -Wall
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(joblimit))
  joblimit := 1
endif

# Separate alternatives into variant (flavor) specific and common.
# For now, we only handle /usr/bin.
var_alternatives := emacsclient
common_alternatives := ctags ebrowse etags

# Info files that are going to show up in the main dir.
main_dir_info_files := efaq.info

# Files that the build stage depends on (may also be listed in other vars).
persistent_autogen_build_files := debian/copyright
nonpersistent_autogen_build_files :=

# These files must always exist, i.e. can't ever be cleaned.
persistent_autogen_install_files :=

nonpersistent_autogen_install_files := \
  debian/emacs-bin-common.postinst \
  debian/emacs-bin-common.prerm \
  debian/emacs-common.README.Debian \
  debian/emacs-common.postinst \
  debian/emacs-common.prerm \
  debian/emacs-nox.lintian-overrides \
  debian/emacs-nox.postinst \
  debian/emacs-nox.prerm \
  debian/emacs-lucid.lintian-overrides \
  debian/emacs-lucid.postinst \
  debian/emacs-lucid.prerm \
  debian/emacs-gtk.lintian-overrides \
  debian/emacs-gtk.postinst \
  debian/emacs-gtk.prerm \
  debian/emacs-pgtk.lintian-overrides \
  debian/emacs-pgtk.postinst \
  debian/emacs-pgtk.prerm

autogen_build_files := \
  $(nonpersistent_autogen_build_files) $(persistent_autogen_build_files)

autogen_install_files := \
  $(nonpersistent_autogen_install_files) $(persistent_autogen_install_files)

persistent_autogen_files := \
  $(persistent_autogen_build_files) $(persistent_autogen_install_files)

nonpersistent_autogen_files := \
  $(nonpersistent_autogen_build_files) $(nonpersistent_autogen_install_files)


# Build directories
pkgdir_common := $(CURDIR)/debian/emacs-common
pkgdir_bin_common := $(CURDIR)/debian/emacs-bin-common
pkgdir_gtk := $(CURDIR)/debian/emacs-gtk
pkgdir_pgtk := $(CURDIR)/debian/emacs-pgtk
pkgdir_nox := $(CURDIR)/debian/emacs-nox
pkgdir_lucid := $(CURDIR)/debian/emacs-lucid
pkgdir_el := $(CURDIR)/debian/emacs-el

install_dir_gtk := $(CURDIR)/debian/install-gtk
install_dir_pgtk := $(CURDIR)/debian/install-pgtk
install_dir_nox := $(CURDIR)/debian/install-nox
install_dir_lucid := $(CURDIR)/debian/install-lucid

libexec_dir_emacs := usr/libexec/emacs/$(runtime_ver)/$(DEB_HOST_GNU_TYPE)

local_lpath := /etc/emacs
local_lpath := $(local_lpath):/usr/local/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/local/share/emacs/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/site-lisp

# Installation local_lpath
local_lpath_install \
  := $(pkgdir_common)/$(subst :,:$(pkgdir_common)/,$(local_lpath))

# If we ever need to do the stripping outside of dh_strip, just add an
# INSTALL_STRIP="-s" to the make vars below.

define emacs_inst
  $(MAKE) -C debian/$(1) install \
    DESTDIR=$(2) \
    infodir=/usr/share/info/emacs \
    localstatedir=/var
endef

# If we ever need it, we can create a copy that doesn't assume ./debian/
define deb_sub
  perl -p \
    -e "s|\@PKG_NAME\@|$(pkg_name)|go;" \
    -e "s|\@MAJOR_VERSION\@|$(major_ver)|go;" \
    -e "s|\@MINOR_VERSION\@|$(minor_ver)|go;" \
    -e "s|\@FULL_VERSION\@|$(runtime_ver)|go;" \
    -e "s|\@PACKAGE_VERSION\@|$(debian_ver)|go;" \
    -e "s|\@DEBIAN_REV\@|$(deb_rev)|go;" \
    -e "s|\@UPSTREAM_VERSION\@|$(upstream_ver)|go;" \
    -e "s|\@DEBSRC_VERSION\@|$(debsrc_ver)|go;" \
    -e "s|\@DEBORIG_VERSION\@|$(deborig_ver)|go;" \
    -e "s|\@MENU_VERSION\@|$(menu_ver)|go;" \
    -e "s|\@X_SUPPORT\@|$(xsupport)|go;" \
    -e "s|\@BIN_PRIORITY\@|$(bin_priority)|go;" \
    -e "s|\@DEB_VAR_ALTERNATIVES\@|$(var_alternatives)|go;" \
    -e "s|\@DEB_COMMON_ALTERNATIVES\@|$(common_alternatives)|go;" \
      < $(1) > $(2)
endef

%:
	dh $@

check-vars:
	@echo "src_name: $(src_name)"
	@echo "upstream_ver: $(upstream_ver)"
	@echo "debian_ver: $(debian_ver)"
	@echo "debsrc_ver: $(debsrc_ver)"
	@echo "deborig_ver: $(deborig_ver)"

## emacs 30.1%2B1

=== debian/changelog ===
emacs (1:30.1+1-5ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Mar 2025 07:50:07 +0200

emacs (1:30.1+1-5) unstable; urgency=medium

  * Disable emacs-module-tests.el (Closes: #1101598).
    These regularly cause FTBFS, i.e., more than just this bug report.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 30 Mar 2025 13:26:28 +0800

emacs (1:30.1+1-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Mar 2025 08:23:44 +0100

emacs (1:30.1+1-4) unstable; urgency=medium

  * Add "Breaks: dh-elpa-helper (<< 2.1.7)" to flavour binary packages.
    Certain addons fail to byte-compile against Emacs 30 unless the
    newer dh-elpa-helper is made available first.
    It is believed, but not confirmed, that this is due to how the
    latest dh-elpa-helper compiles addons using byte-recompile-directory
    instead of batch-byte-compile.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 06 Mar 2025 18:44:41 +0800

emacs (1:30.1+1-3) unstable; urgency=high

  * Disable server-tests/server-force-stop/keeps-frames on riscv64.

  * README.source: Add tasks for separately-packaged built-in libraries.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 26 Feb 2025 17:32:48 +0800

emacs (1:30.1+1-2) unstable; urgency=high

  * Boost BASE_PURESIZE in attempt to fix build on 32-bit archs.
    Thanks to Xiyue Deng for help testing.

  * Use correct upload urgency given security fixes.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 25 Feb 2025 09:21:24 +0800

emacs (1:30.1+1-1) unstable; urgency=medium

  * Merge upstream version 30.1 (Closes: #1088690, #1098255, #1098780).
    - Fixes CVE-2024-53920 and CVE-2025-1244.
    - Drop obsolete patch disabling flymake included-c-header-files test.

  * d/copyright: Updates for Emacs 30.1.
  * d/rules: Adjust for on-by-default native compilation.
  * d/control: Bump dependencies of 'emacs' metapackage.
  * d/control: Remove build dependency on libjansson-dev.
    This is no longer used by Emacs.

  * Fix eldoc warning in patch adding debian-emacs-flavor (Closes: #1095133).
    Thanks to Xiyue Deng for the report and fix.

  * README.source: Suggest using git-range-diff(1) on patch queues.
  * README.source: Bump version numbers in sample commands.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 24 Feb 2025 17:19:10 +0800

emacs (1:29.4+1-6ubuntu3) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Feb 2025 07:01:30 +0100

emacs (1:29.4+1-6) unstable; urgency=medium

  * Disable native compilation on loong64 (Closes: #1095720).
    Thanks to porter Dandan Zhang.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 12 Feb 2025 08:39:57 +0800

## emacs 30.1+1

=== debian/changelog ===
emacs (1:30.1+1-6deepin1) unstable; urgency=medium

  * Port to deepin

 -- April Lu <apr3vau@outlook.com>  Tue, 12 Aug 2025 09:57:00 +0800

emacs (1:30.1+1-6) unstable; urgency=medium

  * Add Breaks/Replaces/Provides for builtin packages in this release.
    See #1103033.  Thanks to Xiyue Deng for the patch.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 18 Jul 2025 09:58:11 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  bsd-mailx | mailx,
  ca-certificates,
  dbus-x11,
- gcc-14,
+ gcc-13,
  debhelper-compat (= 13),
  dpkg-dev (>> 1.10.0),
  git,
@@ -19,14 +19,13 @@
  libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  libcairo-dev,
  libdbus-1-dev,
- libgccjit-14-dev,
+ libgccjit-13-dev,
  libgif-dev,
  libgmp-dev,
  libgnutls28-dev,
  libgpm-dev [linux-any],
  libgtk-3-dev,
  libharfbuzz-dev,
- libjansson-dev,
  libjpeg-dev,
  liblcms2-dev,
  liblockfile-dev,
@@ -58,7 +57,7 @@
 Package: emacs
 Architecture: all
 Depends:
- emacs-gtk (>= 1:27.1) | emacs-pgtk (>= 1:27.1) | emacs-lucid (>= 1:27.1) | emacs-nox (>= 1:27.1),
+ emacs-gtk (>= 1:30.1) | emacs-pgtk (>= 1:30.1) | emacs-lucid (>= 1:30.1) | emacs-nox (>= 1:30.1),
  ${misc:Depends},
 Description: GNU Emacs editor (metapackage)
  GNU Emacs is the extensible self-documenting text editor.
@@ -77,7 +76,7 @@
 Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
 Conflicts: emacs-gtk, emacs-pgtk, emacs-nox
 Replaces: emacs-gtk, emacs-pgtk, emacs-nox, emacs-bin-common (<< 1:29.2)
-Breaks: emacs-bin-common (<< 1:29.2)
+Breaks: emacs-bin-common (<< 1:29.2), dh-elpa-helper (<< 2.1.7)
 Description: GNU Emacs editor (with Lucid GUI support)
  GNU Emacs is the extensible self-documenting text editor.  This
  package contains a version of Emacs with support for a graphical user
@@ -100,7 +99,7 @@
 Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
 Conflicts: emacs-gtk, emacs-pgtk, emacs-lucid
 Replaces: emacs-gtk, emacs-pgtk, emacs-lucid, emacs-bin-common (<< 1:29.2)
-Breaks: emacs-bin-common (<< 1:29.2)
+Breaks: emacs-bin-common (<< 1:29.2), dh-elpa-helper (<< 2.1.7)
 Description: GNU Emacs editor (without GUI support)
  GNU Emacs is the extensible self-documenting text editor.  This
  package contains a version of Emacs compiled without support for X,
@@ -118,7 +117,7 @@
 Suggests: emacs-common-non-dfsg, emacs-editing-major-modes
 Conflicts: emacs-pgtk, emacs-lucid, emacs-nox
 Replaces: emacs-pgtk, emacs-lucid, emacs-nox, emacs-bin-common (<< 1:29.2)
-Breaks: emacs-bin-common (<< 1:29.2)
+Breaks: emacs-bin-common (<< 1:29.2), dh-elpa-helper (<< 2.1.7)
 Description: GNU Emacs editor (with GTK+ GUI support)
  GNU Emacs is the extensible self-documenting text editor.  This
  package contains a version of Emacs with a graphical user interface
@@ -147,6 +146,7 @@
 Breaks:
  emacs-bin-common (<< 1:29.2),
  emacs-common (<< 1:29.3+1-3~),
+ dh-elpa-helper (<< 2.1.7)
 Description: GNU Emacs editor (with GTK+ Wayland GUI support)
  GNU Emacs is the extensible self-documenting text editor.  This
  package contains a version of Emacs with a graphical user interface
@@ -191,17 +191,230 @@
  emacs-gtk (<< 1:25),
  emacs-lucid (<< 1:25),
  emacs-nox (<< 1:25),
+ elpa-allout (<< 2.3),
+ elpa-allout-widgets (<< 1.0),
+ elpa-ansi-color (<< 3.4.2),
+ elpa-antlr-mode (<< 2.2.3),
+ elpa-auth-source-pass (<< 5.0.0),
+ elpa-backtrace (<< 1.0),
+ elpa-bind-key (<< 2.4.1),
+ elpa-cc-mode (<< 5.33.1),
+ elpa-cedet (<< 2.0),
+ elpa-cfengine (<< 1.4),
+ elpa-cl-generic (<< 1.0),
+ elpa-cl-lib (<< 1.0),
+ elpa-cl-print (<< 1.0),
+ elpa-compat (<< 30.1.9999),
+ elpa-ede (<< 2.0),
+ elpa-ediff (<< 2.81.6),
+ elpa-editorconfig (<< 0.11.0),
+ elpa-eglot (<< 1.17.30),
+ elpa-eieio (<< 1.4),
+ elpa-eieio-core (<< 1.4),
+ elpa-eldoc (<< 1.15.0),
+ elpa-epg (<< 1.0.0),
+ elpa-erc (<< 5.6.0.30.1),
+ elpa-eshell (<< 2.4.2),
+ elpa-external-completion (<< 0.1),
+ elpa-faceup (<< 0.0.6),
+ elpa-feedmail (<< 11),
+ elpa-find-cmd (<< 0.6),
+ elpa-flymake (<< 1.3.7),
+ elpa-flymake-proc (<< 1.0),
+ elpa-foldout (<< 1.10),
+ elpa-gnus (<< 5.13),
+ elpa-idlwave (<< 6.1.22),
+ elpa-image-dired (<< 0.5),
+ elpa-info-xref (<< 3),
+ elpa-isearchb (<< 1.5),
+ elpa-js (<< 9),
+ elpa-json (<< 1.5),
+ elpa-jsonrpc (<< 1.0.25),
+ elpa-let-alist (<< 1.0.6),
+ elpa-map (<< 3.3.1),
+ elpa-meta-mode (<< 1.0),
+ elpa-mh-e (<< 8.6~snapshot),
+ elpa-mixal-mode (<< 0.4),
+ elpa-nadvice (<< 1.0),
+ elpa-ntlm (<< 2.1.0),
+ elpa-org (<< 9.7.11),
+ elpa-package (<< 1.1.0),
+ elpa-peg (<< 1.0.1),
+ elpa-project (<< 0.11.1),
+ elpa-ps-mode (<< 1.1.9),
+ elpa-pulse (<< 1.0),
+ elpa-python (<< 0.28),
+ elpa-ruby-mode (<< 1.2),
+ elpa-ruby-ts-mode (<< 0.2),
+ elpa-semantic (<< 2.2),
+ elpa-seq (<< 2.24),
+ elpa-so-long (<< 1.1.2),
+ elpa-soap-client (<< 3.2.3),
+ elpa-sql (<< 3.6),
+ elpa-srecode (<< 1.2),
+ elpa-svg (<< 1.1),
+ elpa-tabulated-list (<< 1.0),
+ elpa-thunk (<< 1.0),
+ elpa-tildify (<< 4.6.1),
+ elpa-track-changes (<< 1.2),
+ elpa-tramp (<< 2.7.1.30.1),
+ elpa-transient (<< 0.7.2.2),
+ elpa-use-package (<< 2.4.6),
+ elpa-vera-mode (<< 2.28),
+ elpa-verilog-mode (<< 2024.3.1.121933719),
+ elpa-viper (<< 3.14.2),
+ elpa-which-key (<< 3.6.0),
+ elpa-whitespace (<< 13.2.2),
+ elpa-window-tool-bar (<< 0.2.1),
+ elpa-xref (<< 1.7.0),
 Replaces:
- emacs-bin-common (<< 1:28)
-Description: GNU Emacs editor's shared, architecture independent infrastructure
- GNU Emacs is the extensible self-documenting text editor.
- This package contains the architecture independent infrastructure
- that's shared by emacs-gtk, emacs-pgtk, emacs-lucid, and emacs-nox.
-
-Package: emacs-el
-Architecture: all
-Depends: emacs-common (= ${source:Version}), ${misc:Depends}
-Description: GNU Emacs LISP (.el) files
- GNU Emacs is the extensible self-documenting text editor.
- This package contains the elisp sources for the convenience of users,
- saving space in the main package for small systems.
+ emacs-bin-common (<< 1:28),
+ elpa-allout (<< 2.3),
+ elpa-allout-widgets (<< 1.0),
+ elpa-ansi-color (<< 3.4.2),
+ elpa-antlr-mode (<< 2.2.3),
+ elpa-auth-source-pass (<< 5.0.0),
+ elpa-backtrace (<< 1.0),
+ elpa-bind-key (<< 2.4.1),
+ elpa-cc-mode (<< 5.33.1),
+ elpa-cedet (<< 2.0),
+ elpa-cfengine (<< 1.4),
+ elpa-cl-generic (<< 1.0),
+ elpa-cl-lib (<< 1.0),
+ elpa-cl-print (<< 1.0),
+ elpa-compat (<< 30.1.9999),
+ elpa-ede (<< 2.0),
+ elpa-ediff (<< 2.81.6),
+ elpa-editorconfig (<< 0.11.0),
+ elpa-eglot (<< 1.17.30),
+ elpa-eieio (<< 1.4),
+ elpa-eieio-core (<< 1.4),
+ elpa-eldoc (<< 1.15.0),
+ elpa-epg (<< 1.0.0),
+ elpa-erc (<< 5.6.0.30.1),
+ elpa-eshell (<< 2.4.2),
+ elpa-external-completion (<< 0.1),
+ elpa-faceup (<< 0.0.6),
+ elpa-feedmail (<< 11),
+ elpa-find-cmd (<< 0.6),
+ elpa-flymake (<< 1.3.7),
+ elpa-flymake-proc (<< 1.0),
+ elpa-foldout (<< 1.10),
+ elpa-gnus (<< 5.13),
+ elpa-idlwave (<< 6.1.22),
+ elpa-image-dired (<< 0.5),
+ elpa-info-xref (<< 3),
+ elpa-isearchb (<< 1.5),
+ elpa-js (<< 9),
+ elpa-json (<< 1.5),
+ elpa-jsonrpc (<< 1.0.25),
+ elpa-let-alist (<< 1.0.6),
+ elpa-map (<< 3.3.1),
+ elpa-meta-mode (<< 1.0),
+ elpa-mh-e (<< 8.6~snapshot),
+ elpa-mixal-mode (<< 0.4),
+ elpa-nadvice (<< 1.0),
+ elpa-ntlm (<< 2.1.0),
+ elpa-org (<< 9.7.11),
+ elpa-package (<< 1.1.0),
+ elpa-peg (<< 1.0.1),
+ elpa-project (<< 0.11.1),
+ elpa-ps-mode (<< 1.1.9),
+ elpa-pulse (<< 1.0),
+ elpa-python (<< 0.28),
+ elpa-ruby-mode (<< 1.2),
+ elpa-ruby-ts-mode (<< 0.2),
+ elpa-semantic (<< 2.2),
+ elpa-seq (<< 2.24),
+ elpa-so-long (<< 1.1.2),
+ elpa-soap-client (<< 3.2.3),
+ elpa-sql (<< 3.6),
+ elpa-srecode (<< 1.2),
+ elpa-svg (<< 1.1),
+ elpa-tabulated-list (<< 1.0),
+ elpa-thunk (<< 1.0),
+ elpa-tildify (<< 4.6.1),
+ elpa-track-changes (<< 1.2),
+ elpa-tramp (<< 2.7.1.30.1),
+ elpa-transient (<< 0.7.2.2),
+ elpa-use-package (<< 2.4.6),
+ elpa-vera-mode (<< 2.28),
+ elpa-verilog-mode (<< 2024.3.1.121933719),
+ elpa-viper (<< 3.14.2),
+ elpa-which-key (<< 3.6.0),
+ elpa-whitespace (<< 13.2.2),
+ elpa-window-tool-bar (<< 0.2.1),
+ elpa-xref (<< 1.7.0),
+Provides:
+ elpa-allout (= 2.3),
+ elpa-allout-widgets (= 1.0),
+ elpa-ansi-color (= 3.4.2),
+ elpa-antlr-mode (= 2.2.3),
+ elpa-auth-source-pass (= 5.0.0),
+ elpa-backtrace (= 1.0),
+ elpa-bind-key (= 2.4.1),
+ elpa-cc-mode (= 5.33.1),
+ elpa-cedet (= 2.0),
+ elpa-cfengine (= 1.4),
+ elpa-cl-generic (= 1.0),
+ elpa-cl-lib (= 1.0),
+ elpa-cl-print (= 1.0),
+ elpa-compat (= 30.1.9999),
+ elpa-ede (= 2.0),
+ elpa-ediff (= 2.81.6),
+ elpa-editorconfig (= 0.11.0),
+ elpa-eglot (= 1.17.30),
+ elpa-eieio (= 1.4),
+ elpa-eieio-core (= 1.4),
+ elpa-eldoc (= 1.15.0),
+ elpa-epg (= 1.0.0),
+ elpa-erc (= 5.6.0.30.1),
+ elpa-eshell (= 2.4.2),
+ elpa-external-completion (= 0.1),
+ elpa-faceup (= 0.0.6),
+ elpa-feedmail (= 11),
+ elpa-find-cmd (= 0.6),
+ elpa-flymake (= 1.3.7),
+ elpa-flymake-proc (= 1.0),
+ elpa-foldout (= 1.10),
+ elpa-gnus (= 5.13),
+ elpa-idlwave (= 6.1.22),
+ elpa-image-dired (= 0.5),
+ elpa-info-xref (= 3),
+ elpa-isearchb (= 1.5),
+ elpa-js (= 9),
+ elpa-json (= 1.5),
+ elpa-jsonrpc (= 1.0.25),
+ elpa-let-alist (= 1.0.6),
+ elpa-map (= 3.3.1),
+ elpa-meta-mode (= 1.0),
+ elpa-mh-e (= 8.6~snapshot),
+ elpa-mixal-mode (= 0.4),
+ elpa-nadvice (= 1.0),
+ elpa-ntlm (= 2.1.0),
+ elpa-org (= 9.7.11),
+ elpa-package (= 1.1.0),
+ elpa-peg (= 1.0.1),
+ elpa-project (= 0.11.1),
+ elpa-ps-mode (= 1.1.9),
+ elpa-pulse (= 1.0),
+ elpa-python (= 0.28),
+ elpa-ruby-mode (= 1.2),
+ elpa-ruby-ts-mode (= 0.2),
+ elpa-semantic (= 2.2),
+ elpa-seq (= 2.24),
+ elpa-so-long (= 1.1.2),
+ elpa-soap-client (= 3.2.3),
+ elpa-sql (= 3.6),
+ elpa-srecode (= 1.2),
+ elpa-svg (= 1.1),
+ elpa-tabulated-list (= 1.0),
+ elpa-thunk (= 1.0),
+ elpa-tildify (= 4.6.1),
+ elpa-track-changes (= 1.2),
+ elpa-tramp (= 2.7.1.30.1),
+ elpa-transient (= 0.7.2.2),
+ elpa-use-package (= 2.4.6),
+ elpa-vera-mode (= 2.28),
+ elpa-verilog-mode (= 2024.3.1.121933719),
+ elpa-viper (= 3.14.2),

=== debian/rules ===
--- 
+++ 
@@ -90,13 +90,6 @@
 endif
 
 deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-
-ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
-  # Building the package with -O3 on ppc64el will cause the
-  # lcms-cri-cam02-ucs test to fail.
-  export DEB_CFLAGS_MAINT_STRIP = -O3
-  export DEB_CFLAGS_MAINT_APPEND = -O2
-endif
 
 CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
 CFLAGS += -Wall
@@ -220,3 +213,11 @@
 	@echo "debian_ver: $(debian_ver)"
 	@echo "debsrc_ver: $(debsrc_ver)"
 	@echo "deborig_ver: $(deborig_ver)"
+	@echo "debian_rev: $(debian_rev)"
+	@echo "runtime_ver: $(runtime_ver)"
+	@echo "major_ver: $(major_ver)"
+	@echo "minor_ver: $(minor_ver)"
+
+.PHONY: check-autogen
+check-autogen: $(persistent_autogen_files) $(nonpersistent_autogen_files)
+

## emacs 30.2%2B1

=== debian/changelog ===
emacs (1:30.2+1-1) unstable; urgency=medium

  * Merge upstream version 30.2
  * Update debian/copyright for 30.2
  * debian/copyright: add entry for emacs_wrench.png.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 09 Nov 2025 16:49:07 -0600

emacs (1:30.1+1-9) unstable; urgency=medium

  * Adjust shr-tests/zoom test to work with libxml2 2.14+ Add
    0023-test-lisp-net-shr-tests.el-shr-test-zoom-image-Fix-i.patch to
    address the issue. Thanks to Matthias Klose for reporting the problem.
    (Closes: #1106354)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 24 Aug 2025 20:04:56 -0500

emacs (1:30.1+1-8) unstable; urgency=medium

  * Upload to unstable.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 10 Aug 2025 10:21:45 +0100

emacs (1:30.1+1-7) experimental; urgency=medium

  * Add & run script to generate Breaks/Replaces/Provides for builtin
    packages during the build (Closes: #1103033).
    Thanks to Xiyue Deng for the script.

  * Backport upstream commit adding builtin packages query interfaces.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 25 Jul 2025 09:37:19 +0100

## emacs 30.2+1

=== test/manual/etags/Makefile ===
ADASRC=$(addprefix ./ada-src/,etags-test-for.ada 2ataspri.adb 2ataspri.ads waroquiers.ada)
ASRC=$(addprefix ./a-src/,empty.zz empty.zz.gz)
CSRC=$(addprefix ./c-src/,abbrev.c .//c.c torture.c getopt.h etags.c\
 exit.c exit.strange_suffix sysdep.h tab.c dostorture.c\
 emacs/src/gmalloc.c emacs/src/regex.h emacs/src/keyboard.c emacs/src/lisp.h\
 machsyscalls.c machsyscalls.h fail.c a/b/b.c) ../etags/c-src/h.h
CPSRC=$(addprefix ./cp-src/,c.C x.cc burton.cpp burton.cpp\
 functions.cpp MDiagArray2.h Range.h\
 screen.cpp screen.hpp conway.cpp conway.hpp clheir.cpp.gz clheir.hpp.gz fail.C)
ELSRC=$(addprefix ./el-src/,TAGTEST.EL emacs/lisp/progmodes/etags.el)
ERLSRC=$(addprefix ./erl-src/,gs_dialog.erl)
FORTHSRC=$(addprefix ./forth-src/,test-forth.fth)
FSRC=$(addprefix ./f-src/,entry.for entry.strange_suffix entry.strange)
GOSRC=$(addprefix ./go-src/,test.go test1.go)
HTMLSRC=$(addprefix ./html-src/,softwarelibero.html index.shtml algrthms.html software.html)
#JAVASRC=$(addprefix ./java-src/, )
LUASRC=$(addprefix ./lua-src/,allegro.lua test.lua)
MAKESRC=$(addprefix ./make-src/,Makefile)
MERCSRC=$(addprefix ./merc-src/,accumulator.m)
OBJCSRC=$(addprefix ./objc-src/,Subprocess.h Subprocess.m PackInsp.h PackInsp.m)
OBJCPPSRC=$(addprefix ./objcpp-src/,SimpleCalc.H SimpleCalc.M)
PASSRC=$(addprefix ./pas-src/,common.pas)
PERLSRC=$(addprefix ./perl-src/,htlmify-cystic yagrip.pl kai-test.pl)
PHPSRC=$(addprefix ./php-src/,lce_functions.php ptest.php sendmail.php)
PSSRC=$(addprefix ./ps-src/,rfc1245.ps)
PROLSRC=$(addprefix ./prol-src/,ordsets.prolog natded.prolog)
PYTSRC=$(addprefix ./pyt-src/,server.py)
RBSRC=$(addprefix ./ruby-src/,test.rb test1.ru)
RSSRC=$(addprefix ./rs-src/,test.rs)
SCMSRC=$(addprefix ./scm-src/,test.scm)
TEXSRC=$(addprefix ./tex-src/,testenv.tex gzip.texi texinfo.tex nonewline.tex)
YSRC=$(addprefix ./y-src/,parse.y parse.c atest.y cccp.c cccp.y)
SRCS=${ADASRC} ${ASRC} ${CSRC} ${CPSRC} ${ELSRC} ${ERLSRC} ${FSRC}\
     ${FORTHSRC} ${GOSRC} ${HTMLSRC} ${JAVASRC} ${LUASRC} ${MAKESRC}\
     ${OBJCSRC} ${OBJCPPSRC} ${PASSRC} ${PHPSRC} ${PERLSRC} ${PSSRC}\
     ${PROLSRC} ${PYTSRC} ${RBSRC} ${RSSRC} ${SCMSRC} ${TEXSRC} ${YSRC} ${MERCSRC}
NONSRCS=./f-src/entry.strange ./erl-src/lists.erl ./cp-src/clheir.hpp.gz

ETAGS_PROG=../../../lib-src/etags
CTAGS_PROG=../../../lib-src/ctags

REGEX=/[ \t]*DEFVAR_[A-Z_ \t\n(]+"\([^"]+\)"/
xx="this line is here because of a fontlock bug

RUN=

OPTIONS=--members --declarations --regex=@regexfile
ARGS=- < srclist

infiles = $(filter-out ${NONSRCS},${SRCS}) srclist regexfile

.PHONY: check cdiff ETAGS CTAGS
# Can't make ediff_1 through ediff_5 .PHONY, as they're implicit.

check:
	@$(MAKE) OPTIONS='--no-members' ediff_1
	@$(MAKE) OPTIONS='--declarations --no-members' ediff_2
	@$(MAKE) OPTIONS='--members' ediff_3
	@$(MAKE) OPTIONS='--regex=@regexfile --no-members' ediff_4
	@$(MAKE) OPTIONS='nonexistent --members --declarations --regex=@regexfile' ediff_5
	@$(MAKE) OPTIONS='--class-qualify --members --declarations --regex=@regexfile' ediff_6
	@$(MAKE) cdiff
	@$(MAKE) ctags_update

ediff%: ETAGS.good% ETAGS ${infiles}
	diff -u --suppress-common-lines --width=80 ETAGS.good$* ETAGS

cdiff: CTAGS.good CTAGS ${infiles}
	diff -u --suppress-common-lines --width=80 CTAGS.good CTAGS

ctags_update: CTAGS.good_update ${infiles}
	head -n 100 CTAGS.good_update > CTAGS
	tail -n 100 CTAGS.good_update >> CTAGS
	${RUN} ${CTAGS_PROG} -o CTAGS -u ${ARGS}
	sort CTAGS > CTAGS.sorted
	sort CTAGS.good_update > CTAGS.good_update.sorted
	diff -u --suppress-common-lines --width=80 CTAGS.good_update.sorted CTAGS.sorted

	cp crlf CTAGS
	${RUN} ${CTAGS_PROG} -o CTAGS -u ${ARGS}
	sort CTAGS > CTAGS.sorted
	sort CTAGS.good_crlf > CTAGS.good_crlf.sorted
	diff -u --suppress-common-lines --width=80 CTAGS.good_crlf.sorted CTAGS.sorted

ETAGS: ${infiles}
	${RUN} ${ETAGS_PROG} ${OPTIONS} -o $@ ${ARGS}

CTAGS: ${infiles}
	${RUN} ${CTAGS_PROG} -o $@ --regex=@regexfile ${ARGS}

srclist: Makefile
	@for i in $(SRCS); do echo $$i; done > srclist
	@echo "srclist remade"

regexfile: Makefile
	@echo '	-- This is for GNU Emacs source files' > regexfile
	@printf '%s\n' '${REGEX}' >> regexfile
	@printf '%s\n' '{c}${REGEX}\\1/m' >> regexfile
	@echo "regexfile remade"

=== debian/changelog ===
emacs (1:30.2+1-2ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.
    - Ignore test results, on riscv64 the package builds with tests disabled
      making lot of sources not able to build there due to missing common
      package

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 22 Nov 2025 21:53:34 +0100

emacs (1:30.2+1-2) unstable; urgency=medium

  [ Rob Browning ]
  * Mark esh-proc-test/kill-pipeline as unstable for now.
    Skip it since it fails sporadically on at least s390x. Add
    0024-Mark-esh-proc-test-kill-pipeline-as-unstable-for-now.patch to
    address the issue.

  [ Sean Whitton ]
  * Boost BASE_PURESIZE further (Closes: #1121058).

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 20 Nov 2025 18:22:13 +0000

emacs (1:30.2+1-1ubuntu2) resolute; urgency=medium

  * Ignore test results, on riscv64 the package builds with tests disabled
    making lot of sources not able to build there due to missing common
    package

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Nov 2025 17:35:55 +0100

emacs (1:30.2+1-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 11 Nov 2025 08:15:29 +0100

emacs (1:30.1+1-9ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Aug 2025 09:19:50 +0200

emacs (1:30.1+1-8ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Test build, ignore test results.
    - Disable shr/zoom-image test, fails with libxml2 2.14.x. See LP #2111576.
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 25 Aug 2025 11:50:59 +0200

emacs (1:30.1+1-6ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Test build, ignore test results.
    - Disable shr/zoom-image test, fails with libxml2 2.14.x. See LP #2111576.
    - d/rules: Build Emacs with -O2 instead of -O3 on ppc64el in order
      to prevent an FTBFS due to lcms-cri-cam02-ucs failing.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Aug 2025 11:18:35 +0200

emacs (1:30.1+1-5ubuntu6) questing; urgency=medium

  * Test build, ignore test results.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 May 2025 16:03:05 +0200

emacs (1:30.1+1-5ubuntu4) questing; urgency=medium

  * Disable shr/zoom-image test, fails with libxml2 2.14.x. See LP #2111576.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 May 2025 12:40:09 +0200

emacs (1:30.1+1-5ubuntu2) questing; urgency=medium

  * No-change rebuild for libtree-sitter0.22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 07 May 2025 10:08:37 +0100

=== debian/rules ===
--- 
+++ 
@@ -90,6 +90,13 @@
 endif
 
 deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
+  # Building the package with -O3 on ppc64el will cause the
+  # lcms-cri-cam02-ucs test to fail.
+  export DEB_CFLAGS_MAINT_STRIP = -O3
+  export DEB_CFLAGS_MAINT_APPEND = -O2
+endif
 
 CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
 CFLAGS += -Wall
@@ -213,11 +220,3 @@
 	@echo "debian_ver: $(debian_ver)"
 	@echo "debsrc_ver: $(debsrc_ver)"
 	@echo "deborig_ver: $(deborig_ver)"
-	@echo "debian_rev: $(debian_rev)"
-	@echo "runtime_ver: $(runtime_ver)"
-	@echo "major_ver: $(major_ver)"
-	@echo "minor_ver: $(minor_ver)"
-
-.PHONY: check-autogen
-check-autogen: $(persistent_autogen_files) $(nonpersistent_autogen_files)
-
